<?php
namespace student\Hw3;

//Including libraries
use seekquarry\yioop\library\CrawlConstants;
use seekquarry\yioop\library\FetchUrl;
use seekquarry\yioop\library\Library;
use seekquarry\yioop\library\processors\HtmlProcessor;
use seekquarry\yioop\library\PhraseParser;

require_once "vendor/autoload.php";

Library::init(true);

//Command line inputs
$lines=file($argv[1],FILE_IGNORE_NEW_LINES); //opens the urls file
$preprocess_type = $argv[2]; //preprocessing function
$params=array();

$key=array(CrawlConstants::URL);

$lineCount=0;

//Create key values for urls
foreach($lines as $line){

    $a=array_fill_keys($key,$line);

    $params[$lineCount]=$a;

    //array_push($a,$line);

    $lineCount=$lineCount+1;

}

//$pages = FetchURL::getPages($params);

$summary_len = 20000;
$max_links = 100;

$sites = FetchURL::getPages($params);

$html_processor = new HtmlProcessor([], $summary_len, $max_links,
    CrawlConstants::CENTROID_WEIGHTED_SUMMARIZER); //Initialising the HTML Page Processor

$total_documents_array = [];

//Iterating through the list of sites
for ($i = 0; $i < count($sites); $i++){
	$summary_info = $html_processor->process($sites[$i][CrawlConstants::PAGE],
    $sites[$i][CrawlConstants::URL]);  //Getting the summary from the sites

	$functions = PhraseParser::getTokenizer("en_US");  //Considering English as the Tokenizer
	$preprocess_summary_array = explode(' ', $summary_info[CrawlConstants::DESCRIPTION]); //Assigning all the terms to an array
	$preprocess_summmary = [""];


	// 'plain' preprocessor
	if($preprocess_type == "plain") {
		$preprocess_summary_array = preg_replace('/[^a-z]+/i', '', $preprocess_summary_array);

		foreach ($preprocess_summary_array as $value) {
			$preprocess_summary_array_lower[] = strtolower($value); //converting the terms to lowercase
		}

		$filtered_array = array_filter($preprocess_summary_array_lower);
	}

	//'stem' preprocessor - Stems the terms to root form
	if($preprocess_type == "stem") {
		$preprocess_summary_array = preg_replace('/[^a-z]+/i', '', $preprocess_summary_array);

		foreach ($preprocess_summary_array as $value) {
			$preprocess_summary_array_lower[] = strtolower($value); //converting the terms to lowercase
		}

		$nonempty_array = array_filter($preprocess_summary_array_lower);

		$filtered_array = array();

		foreach ($nonempty_array as $value) {
			$filtered_array[] = $functions->stem($value);
		}

	}

	//'stop' preprocessor - Removes stop words
	if($preprocess_type == "stop") {
		$preprocess_summary_array = preg_replace('/[^a-z]+/i', '', $preprocess_summary_array);

		foreach ($preprocess_summary_array as $value) {
			$preprocess_summary_array_lower[] = strtolower($value); //converting the terms to lowercase
		}

		$preprocess_summary = $functions->stopwordsRemover($preprocess_summary_array_lower);
		$filtered_array = array_filter($preprocess_summary);

	}

	//'stem' and 'stop' preprocessor - Removes stop words and stems the terms to root form
	if($preprocess_type == "stem_and_stop") {
		$preprocess_summary_array = preg_replace('/[^a-z]+/i', '', $preprocess_summary_array);

		foreach ($preprocess_summary_array as $value) {
			$preprocess_summary_array_lower[] = strtolower($value); //converting the terms to lowercase
		}

		$preprocess_summary = $functions->stopwordsRemover($preprocess_summary_array_lower);

		$nonempty_array = array_filter($preprocess_summary);

		$filtered_array = array();

		foreach ($nonempty_array as $value) {
			$filtered_array[] = $functions->stem($value);
		}
	}

		array_push($total_documents_array, ...$filtered_array);

}

$distinct_terms = array_unique($total_documents_array); //Distinct terms in the array
$posting_size = count($total_documents_array); //size of the posting list
$terms_found = count($distinct_terms); //Total number of distinct terms in the array

    echo "\r\nFile: $argv[1] \r\n";

    echo "Preprocess Type: $argv[2] \r\n";

    echo "Terms found: $terms_found \r\n";

    echo "Posting List Size: $posting_size \r\n";
